format PE GUI 4.0		  ;
entry Start			  ; 
;=====================================================
include "standart.inc"
include "debug.inc"
;====================== ====================
;    ;
;    .
;edx    
AddThread:				;
 inc	[dwCountOfThreads]		; - 
 mov	eax,[dwCountOfThreads]
 mov	ecx,[de.dwThreadId]		; ID 
 push	edi
 mov	edi,[hWarThreads]
 mov	[edi+eax*8],ecx
 mov	[edi+eax*8+4],edx		;  
 pop	edi
SetBP:					;  (edx - )
 mov	[cont.ContextFlags],CONTEXT_DEBUG_REGISTERS
 mov	[cont.iDr7],3			;   
 mov	eax,[dwEntry]
 mov	[cont.iDr0],eax 		;  
 lea	eax,[cont]
 invoke SetThreadContext,edx,eax	;
ret

;   .
; : eax -   ID 
FindThreadHandle:
 mov	eax,[hWarThreads]		; 
 mov	edx,[de.dwThreadId]		;ID   
 ;   ( )
 .for	ecx=[dwCountOfThreads],ecx>0,ecx--,eax+=8
  .exitf edx=[eax]			;:  !
 .endf
ret

Start:					;  
 ;1.  
 xor	ebx,ebx 			; 0  ebx
 sub	esp,V_SIZE
 mov	ebp,esp
 xor	eax,eax 			;  
 mov	edi,ebp
 mov	ecx,V_SIZE/4			;-  
 rep	stosd				;

 invoke HeapAlloc,<invoke GetProcessHeap>,HEAP_ZERO_MEMORY,4096
 mov	[hWarThreads],eax		;   

 ;2.      CreateFileA
 invoke GetProcAddress,<invoke GetModuleHandle,szKernel32>,szCrFile
 mov	[dwEntry],eax			; 

 ;3.  War
 mov	[stui.cb],sizeof.STARTUPINFO	; 
 mov	[stui.dwFlags],STARTF_USESHOWWINDOW
 mov	[stui.wShowWindow],SW_SHOWNORMAL
 lea	eax,[pi]
 push	eax
 lea	eax,[stui]
 push	eax
 invoke CreateProcess,szName,ebx,ebx,ebx,\
	ebx,DEBUG_PROCESS or DEBUG_ONLY_THIS_PROCESS,\
	ebx,ebx

 ;4.   
 l_loop:				;  
  lea	 eax,[de]
  invoke WaitForDebugEvent,eax,INFINITE ;  
  test	 eax,eax
  jz	 l_exit 			;


  ;  
  .if	[de.dwDebugEventCode]=EXCEPTION_DEBUG_EVENT
   ;,   :
   .if [de.Exception.pExceptionRecord.ExceptionCode]=EXCEPTION_BREAKPOINT
    invoke ContinueDebugEvent,[de.dwProcessId],[de.dwThreadId],DBG_CONTINUE
    jmp l_loop				;continue
   .endif				;of EXCEPTION_BREAKPOINT

   ;  
   .if [de.Exception.pExceptionRecord.ExceptionCode]=EXCEPTION_SINGLE_STEP
    ;  ,  
    call FindThreadHandle		;  
    mov esi,[eax+4]			;  

    ;  
    mov [cont.ContextFlags],CONTEXT_DEBUG_REGISTERS
    lea eax,[cont]
    invoke GetThreadContext,esi,eax	;  
    .if [cont.iDr0]=0
     mov edx,esi			; 
     call SetBP 			;   ()
     jmp l_continue			;
    .endif				;of Dr0=0

    ;      
    mov [cont.iDr0],ebx 		;0
    lea eax,[cont]
    invoke SetThreadContext,esi,eax	;

    mov [cont.ContextFlags],CONTEXT_CONTROL
    lea eax,[cont]
    invoke GetThreadContext,esi,eax
    or	[cont.regFlag],FLAG_TF		;TF
    ;  
    mov eax,[cont.regEsp]		;  esp
    add eax,4				;    
    invoke ReadProcessMemory,[pi.hProcess],eax,dwAddr,4,ebx
    invoke ReadProcessMemory,[pi.hProcess],[dwAddr],uBuf,14,ebx
    invoke lstrcmpi,uBuf,szFile 	; 
    .ifz eax				; - war3patch.mpq
     invoke WriteProcessMemory,[pi.hProcess],[dwAddr],szNewFile,N_SIZE,ebx
    .endif
    ;    TF
    lea eax,[cont]
    invoke SetThreadContext,esi,eax	;
    ;  
    invoke ContinueDebugEvent,[de.dwProcessId],[de.dwThreadId],DBG_CONTINUE
    jmp l_loop				;continue
   .endif				;of EXCEPTION_SINGLE_STEP

   ;   War
   invoke ContinueDebugEvent,[de.dwProcessId],[de.dwThreadId],\
	  DBG_EXCEPTION_NOT_HANDLED
  .endif				;of EXCEPTION_DEBUG_EVENT


  .if	[de.dwDebugEventCode]=CREATE_PROCESS_DEBUG_EVENT
   mov	edx,[de.CreateProcessInfo.hThread] ;  ()
   call AddThread			;   
  .endif				;of CREATE_PROCESS_DEBUG_EVENT

  .if	[de.dwDebugEventCode]=CREATE_THREAD_DEBUG_EVENT
   mov	edx,[de.CreateThread.hThread]	; 
   call AddThread			;   
  .endif				;of CREATE_THREAD_DEBUG_EVENT

  .if	[de.dwDebugEventCode]=EXIT_THREAD_DEBUG_EVENT
   ;   :
   call FindThreadHandle
   ; .   ...
   mov	edx,[dwCountOfThreads]		;  
   mov	ecx,[hWarThreads]		; 
   push dword [ecx+edx*8]
   pop	dword [eax]
   push dword [ecx+edx*8+4]
   pop	dword [eax+4]
   dec	[dwCountOfThreads]		; - 
  .endif				;of EXIT_THREAD_DEBUG_EVENT

  .if	[de.dwDebugEventCode]=EXIT_PROCESS_DEBUG_EVENT
   invoke ContinueDebugEvent,[de.dwProcessId],[de.dwThreadId],DBG_CONTINUE
   jmp	l_exit				;
  .endif				;of EXIT_PROCESS_DEBUG_EVENT

  ; 
  l_continue:
  invoke ContinueDebugEvent,[de.dwProcessId],[de.dwThreadId],DBG_CONTINUE
 jmp	 l_loop 			; 

 l_exit:
 invoke ExitProcess,0
;===================== ===================
szKernel32	db 'kernel32.dll',0	; 
szCrFile	db 'CreateFileA',0	;  
szName		db 'war3.exe',0 	;  
szFile		db 'war3patch.mpq',0	;   
C_0:					;  
szNewFile	db 'war3mod.mpq',0	;   
N_SIZE=$-C_0				; 

align 32
dwEntry 	 dd ?			;  
dwCountOfThreads dd 0			;- 
hWarThreads	 dd ?			; 
dwAddr		 dd ?			; 
uBuf		 dd 0,0,0,0,0,0 	;  

virtual at ebp
 C_1:					;  
 pi	PROCESS_INFORMATION		;  
 stui	STARTUPINFO			; 
 de	DEBUG_EVENT			; 
 cont	CONTEXT 			; 
 V_SIZE = $-C_1 			;   
end virtual
;===============  ==========
align 32
data fixups
end data
;==================== ===================
align 32
data import
 library kernel32,'KERNEL32.DLL'

 import kernel32,ExitProcess,'ExitProcess',\
		 GetProcessHeap,'GetProcessHeap',\
		 HeapAlloc,'HeapAlloc',\
		 GetModuleHandle,'GetModuleHandleA',\
		 GetProcAddress,'GetProcAddress',\
		 CreateProcess,'CreateProcessA',\
		 WaitForDebugEvent,'WaitForDebugEvent',\
		 SetThreadContext,'SetThreadContext',\
		 GetThreadContext,'GetThreadContext',\
		 ContinueDebugEvent,'ContinueDebugEvent',\
		 ReadProcessMemory,'ReadProcessMemory',\
		 WriteProcessMemory,'WriteProcessMemory',\
		 lstrcmpi,'lstrcmpiA'
end data